// Korea Scientifics, Inc. Yellow Cat Arduino Car Line Tracer

const int LeftPaw= 5; // 왼쪽 라인트레이서 센서의 신호 선은 5번으로 정의
const int RightPaw= 4; // 오른쪽 라인트레이서 센서의 신호 선은 4번으로 정의
const int motorLeftF =11; // 왼쪽 모터의 전진 신호는 11번으로 정의
const int motorLeftB =10; // 왼쪽 모터의 후진 신호는 10번으로 정의
const int motorRightF=6; // 오른쪽 모터의 전진 신호는 6번으로 정의
const int motorRightB=9; // 오른쪽 모터의 전진 신호는 9번으로 정의
int speed=150;

void setup() {
	pinMode(LeftPaw, INPUT);
	pinMode(RightPaw, INPUT);
	pinMode(motorLeftF, OUTPUT);
	pinMode(motorLeftB, OUTPUT);
	pinMode(motorRightF, OUTPUT);
	pinMode(motorRightB, OUTPUT);
}

void loop() { //모터의 속도는 0~255 사이의 숫자로 설정(100 이하에서는 모터가 작동 하지 않을 수 있습니다.)
	int duration =10; 
	if(digitalRead(LeftPaw)==LOW){ //왼쪽 라인 센서가 선을 감지
	 	left(0); right(speed);  // 정지 //왼쪽으로 회전(왼쪽 모터 정지, 오른쪽 모터 구동)
	 	delay(duration);
	 	left(0); right(0);  // 정지
	}
	else if(digitalRead(RightPaw)==LOW){ //오른쪽 라인 센서가 선을 감지
		left(speed); right(0);  // 정지 //오른쪽으로 회전(왼쪽 모터 구동, 오른쪽 모터 정지)
	 	delay(duration);
	 	left(0); right(0);  // 정지
	} 
	else{
		left(speed); right(speed);  // 정지 // 양쪽 라인 센서 모두가 선을 감지하지 않으면 직진
		duration=30; // 30ms 동안
	}
 	delay(duration);
}

void left(int speed){ //왼쪽 모터 제어 
	if (speed >= 0) { //전진
		digitalWrite(motorLeftB, LOW); //왼쪽 후진 신호 OFF
		analogWrite(motorLeftF, speed); //전진 신호 speed의 세기로 회전
	} else { //후진인 경우
		digitalWrite(motorLeftF, LOW); //왼쪽 후진 신호 OFF
		analogWrite(motorLeftB, -speed); //후진 신호 양수로 변경된 speed의 세기로 회전
	}
}

void right(int speed){ //오른쪽 모터 제어 
	if (speed >= 0) { //전진
		digitalWrite(motorRightB, LOW); //오른쪽 후진 신호 OFF
		analogWrite(motorRightF, speed); //전진 신호 speed의 세기로 회전 
	} else { //후진인 경우
		digitalWrite(motorRightF, LOW); //오른쪽 전진 신호 OFF
		analogWrite(motorRightB, -speed); //후진 신호 양수로 변경된 speed의 세기로 회전
	}
}
